{{- range .Values.webServices -}}

{{- $commitSha := $.Values.commitSha }}
{{- $prefix := $.Values.prefix }}
{{- $namespace := $.Values.namespace }}
{{- $scope := print $.Values.prefix "-" $.Values.namespace }}
{{- $deployScope := print $scope "-" .name -}}

apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ $deployScope }}-deployment
  namespace: {{ $namespace }}
  labels:
    app: {{ $deployScope }}
    prefix: {{ $prefix }}
    scope: {{ $scope }}
spec:
  replicas: {{ .replicas | default 1 }}
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 1
      maxUnavailable: 1
  selector:
    matchLabels:
      app: {{ $deployScope }}
  template:
    metadata:
      labels:
        app: {{ $deployScope }}
    spec:
      containers:
      {{- range .pods -}}
      - name: {{ $deployScope }}-{{ .name }}
        image: {{ .image }}:{{ $commitSha }}
        imagePullPolicy: Always
        ports:
          {{- range .ports -}}
          - containerPort: {{ .containerPort }}
            name: {{ .name }}
          {{- end }}
          -
        {{- if .healthProbe }}
        {{- with .healthProbe }}
        livenessProbe:
          httpGet:
            path: {{ .path }}
            port: {{ .port }}
          initialDelaySeconds: 10
          timeoutSeconds: 1
          periodSeconds: 10
        {{- end }}
        {{- end }}

        {{- if .readinessProbe }}
        {{- with .readinessProbe  }}
        readinessProbe:
          httpGet:
            path: {{ .path }}
            port: {{ .port }}
          initialDelaySeconds: 10
          timeoutSeconds: 1
          periodSeconds: 10
        {{- end }}
        {{- end }}

        env:
        {{- range $name, $value := .configMapValues }}
        - name: {{ $name }}
          value: {{ tpl $value $ | default $value | quote }}
        {{- end }}

        {{- range $name, $key := .configMapRefs }}
        - name: {{ $name }}
          valueFrom:
            configMapKeyRef:
              name: {{ $scope }}-configmap
              key: {{ $key }}
        {{- end }}

        {{- range $name, $key := .secretRefs }}
        - name: {{ $name }}
          valueFrom:
            secretKeyRef:
              name: {{ $scope }}-secrets
              key: {{ $key }}
        {{- end }}

      {{- end }}
___

{{- end }}